Simple, modern & fast web-based email client https://snappymail.eu
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 
the-djmaze 2f4e17da51 HighestModSeq vs Highestmodseq (camel-case) 1 day ago
.docker v2.22.4 3 days ago
.github
assets
build Minify plugins JavaScript on build 2 days ago
cli
data
dev Resolve #728 by removing impossible button 1 day ago
fail2ban
integrations v2.22.4 3 days ago
plugins Avatars plugin added other identicon types (needs config settings) 1 day ago
snappymail/v/0.0.0 HighestModSeq vs Highestmodseq (camel-case) 1 day ago
tasks
test
vendors Update to OpenPGP.js v5.5.0 6 days ago
.browserslistrc
.cmds
.editorconfig
.eslintignore Add prettier 3 years ago
.eslintrc.js
.gitignore
.gitmodules
.htaccess
.prettierignore
.prettierrc
CHANGELOG.md v2.22.4 3 days ago
CODE_OF_CONDUCT.md
CONTRIBUTING.md
LICENSE
Makefile
README.md v2.22.4 3 days ago
SECURITY.md
_include.php
docker-compose.yml
gulpfile.js
index.php
jsconfig.json
package.json v2.22.4 3 days ago
release.php v2.22.3 6 days ago
rollup.config.js
template.env
yarn.lock

README.md


SnappyMail


Simple, modern, lightweight & fast web-based email client.

The drastically upgraded & secured fork of RainLoop Webmail Community edition.

We thank the RainLoop Team for making a great PHP 5 product that was good in the past.

Up to date system requirements, snappy performance, simple installation and upgrade, no database required - all these make SnappyMail a good choice.


For more information about the product, check snappymail.eu.

Information about installing the product, check the wiki page.

And don't forget to read the RainLoop documentation.

License

SnappyMail is released under GNU AFFERO GENERAL PUBLIC LICENSE Version 3 (AGPL). http://www.gnu.org/licenses/agpl-3.0.html

Copyright (c) 2020 - 2022 SnappyMail Copyright (c) 2013 - 2022 RainLoop

Modifications

This fork of RainLoop has the following changes:

  • Privacy/GDPR friendly (no: Social, Gravatar, Facebook, Google, Twitter, DropBox, X-Mailer)
  • Admin uses password_hash/password_verify
  • Auth failed attempts written to syslog
  • Added Fail2ban instructions
  • ES2018
  • PHP 7.4+ required
  • PHP mbstring extension required
  • PHP replaced pclZip with PharData and ZipArchive
  • Dark mode
  • Added option to remove background/font colors from messages for real "dark mode"
  • Removed BackwardCapability (class \RainLoop\Account)
  • Removed ChangePassword (re-implemented as plugin)
  • Removed POP3 support
  • Removed background video support
  • Removed Sentry (Application Monitoring and Error Tracking Software)
  • Removed Spyc yaml
  • Removed OwnCloud
  • Replaced gulp-uglify with gulp-terser
  • CRLF => LF line endings
  • Embed boot.js and boot.css into index.html
  • Removal of old JavaScript code (things are native these days)
  • Added modified Squire HTML editor as replacement for CKEditor
  • Updated Sabre/VObject
  • Split Admin specific JavaScript code from User code
  • Split Sieve specific JavaScript code from User code
  • JSON reviver
  • Better memory garbage collection management
  • Added serviceworker for Notifications
  • Added advanced Sieve scripts editor
  • Slimmed down language files
  • Replaced webpack with rollup
  • No user-agent detection (use device width)
  • Added support to load plugins as .phar
  • Replaced old Sabre library
  • AddressBook Contacts support MySQL/MariaDB utf8mb4
  • Added Fetch Metadata Request Headers checks
  • Reduced excessive DOM size
  • Support Kolab groupware
  • Support IMAP RFC 2971 ID extension
  • Support IMAP RFC 5258 LIST-EXTENDED
  • Support IMAP RFC 5464 METADATA
  • Support IMAP RFC 5819 LIST-STATUS
  • Support IMAP RFC 7628 SASL OAUTHBEARER aka XOAUTH2
  • Support IMAP4rev2 RFC 9051
  • Support Sodium and OpenSSL for encryption
  • Much better PGP support

Supported browsers

This fork uses downsized/simplified versions of scripts and has no support for Internet Explorer nor Edge Legacy. Supported are:

  • Chrome 80+
  • Edge 80+
  • Firefox 78+
  • Opera 67+
  • Safari 13.1+

Removal of old JavaScript

The result is faster and smaller download code (good for mobile networks).

  • Added dev/prototype.js for some additional features
  • Modified Jua.js to be without jQuery
  • Replaced Autolinker with simple https/email detection
  • Replaced momentToNode with proper HTML5 <time>
  • Replaced resize listeners with ResizeObserver
  • Replaced bootstrap.js with native drop-in replacement
  • Replaced dev/Common/ClientStorageDriver/* with Web Storage Objects polyfill
  • Replaced *Ajax with *Fetch classes because we use the Fetch API, not jQuery.ajax
  • Replaced knockoutjs 3.4 with a modified 3.5.1
  • Replaced knockout-sortable with native HTML5 drag&drop
  • Replaced simplestatemanager with CSS @media
  • Replaced inputosaurus with own code
  • Replaced keymaster with own shortcuts handler
  • Replaced OpenPGP.js v2 with OpenPGP.js v5
  • Removed ifvisible.js
  • Removed pikaday
  • Removed underscore
  • Removed polyfills
  • Removed Modernizr
  • Removed nanoscroll
  • Removed lightgallery
  • Removed jQuery
  • Removed jquery-ui
  • Removed jquery-scrollstop
  • Removed jquery-mousewheel
  • Removed matchmedia-polyfill
  • Removed momentjs (use Intl)
  • Removed opentip (use CSS)
  • Removed non-community (aka Prem/Premium/License) code
  • Removed ProgressJS

RainLoop 1.17 vs SnappyMail

js/* RainLoop Snappy
admin.js 2.170.153 82.419
app.js 4.207.787 407.334
boot.js 868.735 2.351
libs.js 658.812 193.075
sieve.js 0 86.121
polyfills.js 334.608 0
serviceworker.js 0 285
TOTAL 8.240.095 771.585
js/min/* RainLoop Snappy RL gzip SM gzip RL brotli SM brotli
admin.min.js 256.831 40.933 73.606 13.575 60.877 12.185
app.min.js 515.367 188.876 139.456 62.841 110.485 53.957
boot.min.js 84.659 1.474 26.998 907 23.643 733
libs.min.js 584.772 92.084 180.901 34.119 155.182 30.621
sieve.min.js 0 41.926 0 10.484 0 9.451
polyfills.min.js 32.837 0 11.406 0 10.175 0
TOTAL user 1.217.635 282.434 358.761 97.867 299.485 85.311
TOTAL user+sieve 1.217.635 324.360 358.761 108.351 299.485 94.762
TOTAL admin 959.099 134.491 292.911 48.601 249.877 43.539

For a user its around 70% smaller and faster than traditional RainLoop.

CSS changes

  • Solve jQuery removed "features" with native css code
  • Themes work in mobile mode
  • Bugfix invalid/conflicting css rules
  • Use flexbox
  • Use border-box
  • Split app.css to have separate admin.css
  • Remove oldschool 'float'
  • Remove unused css
  • Removed html.no-css
  • Removed dev/Styles/Cmd.less
  • Removed dev/Styles/Scroll.less
  • Removed Internet Explorer from normalize.css
  • Removed node_modules/opentip/css/opentip.css
  • Removed node_modules/pikaday/css/pikaday.css
  • Removed unused vendors/bootstrap/less/*
  • Removed vendors/jquery-nanoscroller/nanoscroller.css
  • Removed vendors/jquery-letterfx/jquery-letterfx.min.css
  • Removed vendors/Progress.js/minified/progressjs.min.css
  • Removed gulp-autoprefixer
css/* RainLoop Snappy RL gzip SM gzip SM brotli
app.css 340.331 81.910 46.946 17.050 14.596
app.min.css 274.947 66.076 39.647 15.042 13.205
boot.css 1.326 664 545
boot.min.css 1.071 590 474
admin.css 29.853 6.812 5.933
admin.min.css 24.269 6.210 5.480

PGP

RainLoop uses the old OpenPGP.js v2 SnappyMail v2.12 uses OpenPGP.js v5, GnuPG and Mailvelope. SnappyMail is able to use and generate ECDSA and EDDSA keys, where RainLoop does not.

Since SnappyMail tries to achieve the best mobile experience, it forked OpenPGP.js to strip it down.

OpenPGP RainLoop Snappy RL gzip SM gzip RL brotli SM brotli
openpgp.min.js 330.742 539.988 102.388 167.371 84.241 137.413
openpgp.worker 1.499 824 695

Squire vs CKEditor

The Squire implementation is not 100% compatible yet, but it shows the massive overhead of CKEditor.

Still TODO:

  • support for tables (really needed?!?)
  • support BIDI (really needed?!?)
normal min gzip min gzip
squire 122.321 41.906 31.867 14.330
ckeditor ? 520.035 ? 155.916

CKEditor including the 7 asset requests (css,language,plugins,icons) is 633.46 KB / 180.47 KB (gzip).

To use the old CKEditor, you must install the plugin.